//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F6F20500053.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F6F20500053.cm

//## begin module%3F6F20500053.cp preserve=no
//## end module%3F6F20500053.cp

//## Module: Projection%3F6F20500053; Package body
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/Projection.cxx

//## begin module%3F6F20500053.additionalIncludes preserve=no
//## end module%3F6F20500053.additionalIncludes

//## begin module%3F6F20500053.includes preserve=yes
//## end module%3F6F20500053.includes

// DataContainer
#include <XSModel/GlobalContainer/DataContainer.h>
// Projection
#include "Projection.h"


//## begin module%3F6F20500053.declarations preserve=no
//## end module%3F6F20500053.declarations

//## begin module%3F6F20500053.additionalDeclarations preserve=yes
using namespace XSContainer;
#include <XSModel/Data/SpectralData.h>
#include <XSUtil/Numerics/LinearInterp.h>
#include <cmath>
#include <XSContainer.h>
#include <XSstreams.h>
//## end module%3F6F20500053.additionalDeclarations


// Class Projection::Ellipsoid 

//## begin Projection::Ellipsoid::FLAG%3FA13B0D0276.attr preserve=no  public: static Real {U} 999.
Real Projection::Ellipsoid::FLAG = 999.;
//## end Projection::Ellipsoid::FLAG%3FA13B0D0276.attr

Projection::Ellipsoid::Ellipsoid (Real maj, Real min, Real orient)
  //## begin Projection::Ellipsoid::Ellipsoid%3FA13AE1005C.hasinit preserve=no
      : a(maj),
        b(min),
        orientation(orient),
        innerShellNum(-1)
  //## end Projection::Ellipsoid::Ellipsoid%3FA13AE1005C.hasinit
  //## begin Projection::Ellipsoid::Ellipsoid%3FA13AE1005C.initialization preserve=yes
  //## end Projection::Ellipsoid::Ellipsoid%3FA13AE1005C.initialization
{
  //## begin Projection::Ellipsoid::Ellipsoid%3FA13AE1005C.body preserve=yes
  //## end Projection::Ellipsoid::Ellipsoid%3FA13AE1005C.body
}


int Projection::Ellipsoid::operator==(const Projection::Ellipsoid &right) const
{
  //## begin Projection::Ellipsoid::operator==%3F6F32070062_eq.body preserve=yes
  // for ellipsoids, equality is defined only up to major, minor axes and
  // orientation. sections can be different.
  return   (a == right.a) && (b == right.b) && (orientation == right.orientation);  
  //## end Projection::Ellipsoid::operator==%3F6F32070062_eq.body
}

int Projection::Ellipsoid::operator!=(const Projection::Ellipsoid &right) const
{
  //## begin Projection::Ellipsoid::operator!=%3F6F32070062_neq.body preserve=yes
  return !operator==(right);
  //## end Projection::Ellipsoid::operator!=%3F6F32070062_neq.body
}


// Class Projection 

//## begin Projection::DEG2RAD%3F6F3FBD036C.attr preserve=no  private: static Real {UC} std::atan(1.)/45.
const Real Projection::DEG2RAD = std::atan(1.)/45.;
//## end Projection::DEG2RAD%3F6F3FBD036C.attr

//## begin Projection::FOURPIBY3%3F6F461402A8.attr preserve=no  private: static Real {UC} 16.*std::atan(1.)/3.
const Real Projection::FOURPIBY3 = 16.*std::atan(1.)/3.;
//## end Projection::FOURPIBY3%3F6F461402A8.attr

Projection::Projection (const string& name)
  //## begin Projection::Projection%405B1C56001E.hasinit preserve=yes
  : MixBase(name)
  //## end Projection::Projection%405B1C56001E.hasinit
  //## begin Projection::Projection%405B1C56001E.initialization preserve=yes
  //## end Projection::Projection%405B1C56001E.initialization
{
  //## begin Projection::Projection%405B1C56001E.body preserve=yes
  //## end Projection::Projection%405B1C56001E.body
}


Projection::~Projection()
{
  //## begin Projection::~Projection%3F6F1D3C000C_dest.body preserve=yes
  //## end Projection::~Projection%3F6F1D3C000C_dest.body
}



//## Other Operations (implementation)
void Projection::initialize (const std::vector<Real>& params, const std::string& modelName)
{
  //## begin Projection::initialize%3F6F1D5601C6.body preserve=yes
  // safety measure. Since initialize is not called that often, add
  // a check one more time that the data are present and compatible
  // with the model. verifyData() throws a number of different exceptions
  // if not.
  verifyData();
  // ASSUME mix models are only assigned to SOURCE NUMBER 1.
  const size_t SOURCENUM = 1;
  // verifyData has already proven that this entry exists.
  const std::map<size_t,size_t> & dgMap = 
                datasets->sourceToDgs().find(SOURCENUM)->second;
  m_numberOfShells = dgMap.size();
  // m_observations was actually determined at the end of verifyData 
  // (equalling the groupCount), but it can't be set there since that's
  // a const function.  Nor can it be passed here without changing the
  // signature of verifyData for all mixing subclasses.  Therefore 
  // redundantly determine it here (just need to count for one group). 
  size_t count=0;
  size_t iGroup = dgMap.begin()->first; 
  size_t nTotalSpec = datasets->numberOfSpectra();
  for (size_t iSpec=1; iSpec<=nTotalSpec; ++iSpec)
  {
     const SpectralData* spec = datasets->lookup(iSpec);
     if (spec->parent()->dataGroup() == iGroup && spec->detector(SOURCENUM-1))
        ++count;
  } 
  m_observations = count;
                  
  bool centre(false);
  if ( centre = (params[0] > 0 && params[1] > 0)) ++m_numberOfShells;
  m_shell.resize(m_observations);
  for (size_t iObs=0; iObs<m_observations; ++iObs)
     m_shell[iObs].resize(m_numberOfShells);
  m_maximumSections = 1;
  // If the observation 1 files are o1a1, o1a2, o1a3 and the 
  // observation 2 files are o2a1, o2a2, o2a3 then they should
  // be read in using: 
  // XSPEC> data 1:1 o1a1 1:2 o2a1 2:3 o1a2 2:4 o2a2 3:5 o1a3 3:6 o2a3
  
  // ...but, since we're now allowing interspersed spectra that don't use
  // this model, we can no longer so easily obtain the obs number from
  // the spectrum number.  We CAN still assume obs number increases
  // consecutively within each data group for the spectra that ARE using
  // this model, so keep track of things with a counter for each 
  // data group (or annulus).
  // (m_numberOfShells will be one larger than necessary for obsCounter
  // if using center, but no problem since that element will be ignored.)
  std::vector<size_t> obsCounter(m_numberOfShells, 0);
  for (size_t iSpec=1; iSpec<=nTotalSpec; ++iSpec)
  {
     const SpectralData* spec = datasets->lookup(iSpec);
     if (spec->detector(SOURCENUM-1))
     {
        size_t groupNum = spec->parent()->dataGroup();
        // No need to verify find iterator if it passed verifyData.
        size_t groupPosNum = dgMap.find(groupNum)->second-1;
        size_t iObs = obsCounter[groupPosNum]++;
        createEllipsoidDescriptions(iObs, iSpec, groupPosNum);
     }
  }
  if ( centre )
  {
     for (size_t iObs=0; iObs<m_observations; ++iObs)
     {
        Ellipsoid& centre = m_shell[iObs][m_numberOfShells-1];
        centre.a = params[0];
        centre.b = params[1];
        centre.orientation = params[2];         
        centre.angleBound.resize(1);
        centre.angleBound[0].first = 0;
        centre.angleBound[0].second = 360.;
     }
  }
   
  orderEllipsoids(centre);
  
  if ( changedProjection() )
  {      
     m_matrix.resize(m_observations);
     for (size_t observation = 0; observation < m_observations; ++observation)
     {
        m_matrix[observation].assign(m_numberOfShells*m_numberOfShells,0.);
        defineMatrix(observation);
     }        
  }        
  m_previousShell = m_shell;
  
  //## end Projection::initialize%3F6F1D5601C6.body
}

Real Projection::element (size_t observation, int shellNumber, int ellipseNumber, int sectionNumber) const
{
  Real result(0);

  //## begin Projection::element%3F6F39F10309.body preserve=yes
  static const size_t NSTEPS (5000);
  static const Real twoThirds (2./3.);
// Calculate the fraction of the volume of the prolate ellipsoid with axes/orientation
// defined by m_shell[shellNumber] that lies within the projected ellipse with
// axes/orientation defined by m_shell[ellipseNumber] with sections defined by the
// m_shell angleBound vector pair.   [ m_shell is of type vector<Ellipsoid> ]


// Integral to be calculated is 
//
//  V = 2/3 Int_(ph1-theta)^(ph2-theta) dx b^3 (1 + (b^2/a^2-1) cos^2 x)^-1
//
//    - 2/3 Int_(ph1-theta)^(ph2-theta) dx beta^3 
//
//             (1 + (beta^2/alpha^2-1) cos^2 (x+theta-phi))^-3/2
//
//            ((b^2/beta^2)(1 + (beta^2/alpha^2-1) cos^2 (x+theta-phi)) - 1
//
//            - (b^2/a^2-1) cos^2 x)^3/2 (1 + (b^2/a^2-1) cos^2 x)^-1
//
//  where a,b,theta describe the ellipsoid and alpha,beta,phi,ph1,ph2 the 
//  2-D ellipse.

     const std::vector<Ellipsoid>& shell = m_shell[observation];
     
     
     const Real& shellMinor = shell[shellNumber].b;
     const Real& shellMajor = shell[shellNumber].a;
     const Real& shellOrient = shell[shellNumber].orientation;
     const Real& annulusMinor = shell[ellipseNumber].b;
     const Real& annulusMajor = shell[ellipseNumber].a;
     const Real& annulusOrient = shell[ellipseNumber].orientation;
     const std::vector<std::pair<Real,Real> >& sections  = shell[sectionNumber].angleBound;
     
     const size_t nSects (sections.size());
     
     Real shMin3 (shellMinor*shellMinor*shellMinor);
     Real annMin3 (annulusMinor*annulusMinor*annulusMinor);
     Real shellAnn2    = (shellMinor/annulusMinor)*(shellMinor/annulusMinor);
     Real shellRat2minus1  = (shellMinor/shellMajor)*(shellMinor/shellMajor) - 1.;
     Real annRat2minus1    = (annulusMinor/annulusMajor)*(annulusMinor/annulusMajor) - 1.;
     Real orientDiff   = ( shellOrient - annulusOrient )*DEG2RAD;
     
     // Loop round sections. There's always at least one...
     for ( size_t j = 0; j < nSects; ++j )
     {
        Real angle1 ( DEG2RAD*(sections[j].first  - shellOrient) );
        Real angle2 ( DEG2RAD*(sections[j].second - shellOrient) );
        Real dx  ( (angle2 - angle1)/ NSTEPS );
        Real Sum (0.);
        Real x (angle1 - 0.5*dx);
        // The integrand is smoothly varying so can use BFI and divide into NSTEP
        // steps from the start to end angles.

        for ( size_t i = 0; i < NSTEPS; ++i )
        {
           x += dx;
           Real cosx  (std::cos(x));
           Real cosx0 (std::cos(x + orientDiff));
           Real cosSqX  (cosx*cosx);
           Real cosSqXO (cosx0*cosx0);    
           Real f1 ( 1. +  shellRat2minus1*cosSqX );
           Real f2 ( 1. +    annRat2minus1*cosSqXO );
           if (  (shellAnn2*f2 - f1) > 0 )
           {
              Real RR ( (shellAnn2*f2 - f1)/f2 );
              Sum += shMin3/f1 - annMin3 * sqrt ( RR*RR*RR );
           }
           else
           {
              Sum += shMin3/f1;
           }
        }   
        result += twoThirds*Sum*dx;                        
     }
  //## end Projection::element%3F6F39F10309.body

  return result;
}

void Projection::defineMatrix (size_t observation)
{
  //## begin Projection::defineMatrix%3F6F3A3201A6.body preserve=yes
        
  // equivalent of calprj. returns a projection matrix for each observation.
              
  
  
  for (size_t j = 0; j < m_numberOfShells; ++j)
  {
     int Inshell (0);
// j is the target ellipse. Find the ellipse immediately interior to the 
// current one so that we can subtract off the contributions interior to the
// defined annulus...
        
     Real majorInShell = interiorVolume(observation, j, Inshell);

// loop around contributing shells. 
        
     for (size_t i = 0; i < m_numberOfShells; ++i )
     {
        std::vector<Ellipsoid>& shell = m_shell[observation];
        if ( shell[i].a >= shell[j].a )
        {
            Real el_ijj (element(observation,i,j,j));
            if ( majorInShell != 0) el_ijj -= element(observation,i,Inshell,j);
            setProjectionElement(observation,i,j,el_ijj);       
            if (tpout.maxChatter() >= 30)
            { 
               tcout << "matrix(i,j) @ obs " << i << " " << j << " " 
                     << observation  << " : " << el_ijj << std::endl;
            }
        }
     }
  }
  //## end Projection::defineMatrix%3F6F3A3201A6.body
}

void Projection::createEllipsoidDescriptions (size_t observation, size_t spectrumNumber, size_t iShell)
{
  //## begin Projection::createEllipsoidDescriptions%3F6F3AE702DD.body preserve=yes
  
    // set the size of the Ellipsoid vector (m_shell) before entering this function.
        
    std::vector<Ellipsoid>& shell = m_shell[observation];  
    SpectralData* spectrum (datasets->lookup(spectrumNumber));      
    const std::map<size_t, Real>& filterKeys = spectrum->xflt();  
    size_t N (filterKeys.size());  
  
    if (N < 3) 
    {
        string diag(" 3 keywords (major, minor axes and orientation) required");
	throw IncompatibleData(diag);
    }
    Ellipsoid& currShell = shell[iShell];
    currShell.a = filterKeys.find(1)->second;
    currShell.b = filterKeys.find(2)->second;
    currShell.orientation = filterKeys.find(3)->second;
  
    if (N <= 4)
    {
       currShell.angleBound.resize(1);
       currShell.angleBound[0].first = 0.0;
       currShell.angleBound[0].second = 360.0;
    }
    else
    {
       currShell.angleBound.resize( (N-3)/2 );
       m_maximumSections = std::max(m_maximumSections, (N-3)/2 );   
       for ( size_t j = 3; j < N; j +=2 )
       {
           currShell.angleBound[(j-3)/2].first = filterKeys.find(j + 1)->second;
           if ( N > j+1 ) 
	       currShell.angleBound[(j-3)/2].second = filterKeys.find(j+2)->second;   
       }
    }
        
  //## end Projection::createEllipsoidDescriptions%3F6F3AE702DD.body
}

Real Projection::interiorVolume (size_t observation, int ellipseNumber, int& shellNumber) const
{
  //## begin Projection::interiorVolume%3F6F3BC800BA.body preserve=yes
  Real axisLength = 0.0;
  const std::vector<Ellipsoid>& shells = m_shell[observation];
  // sets the shell number of the volume interior to ellipseNumber and returns
  // its major axis length
  const Ellipsoid& shell = shells[ellipseNumber];
  shellNumber = shell.innerShellNum;
  if (shellNumber >= 0)
     axisLength = shells[shellNumber].a;
  
  return axisLength;
  //## end Projection::interiorVolume%3F6F3BC800BA.body
}

bool Projection::changedProjection () const
{
  bool changed(true);

  //## begin Projection::changedProjection%3F6F3D2A02F5.body preserve=yes
  if (!m_shell.empty() && m_shell.size() ==  m_previousShell.size()) 
  {
     changed = false;
     if (m_shell[0].size() != m_previousShell[0].size())
        changed = true;
     for (size_t i = 0; i < m_numberOfShells && !changed; ++ i)
     {
        for ( size_t j = 0; j < m_observations && !changed; ++j)
        {                
           const std::vector<Ellipsoid>& shell = m_shell[j];        
           const std::vector<Ellipsoid>& previousShell = m_previousShell[j]; 

           if ( shell[i].a != previousShell[i].a ||  
                shell[i].b != previousShell[i].b ||      
                shell[i].orientation != previousShell[i].orientation ||
                shell[i].angleBound.size() !=  previousShell[i].angleBound.size() )
           {
              changed = true;
           } 
           else
           {
              size_t Nsects (shell[i].angleBound.size());
              for (size_t k = 0; k < Nsects; ++k)
              {
                 if (shell[i].angleBound[k].first 
                               != previousShell[i].angleBound[k].first ||
                     shell[i].angleBound[k].second 
                               != previousShell[i].angleBound[k].second )
                 {
                    changed = true;
                    break;
                 }            
              }
           }                                  
        }       
     }     
  }
  //## end Projection::changedProjection%3F6F3D2A02F5.body

  return changed;
}

Real Projection::projectionElement (size_t observation, int nshell, int mshell) const
{
  //## begin Projection::projectionElement%3F6F3D9A00DA.body preserve=yes
  return m_matrix[observation][m_numberOfShells*mshell + nshell];
  //## end Projection::projectionElement%3F6F3D9A00DA.body
}

void Projection::setProjectionElement (size_t observation, int nshell, int mshell, Real value)
{
  //## begin Projection::setProjectionElement%3F6F619E00A3.body preserve=yes
  m_matrix[observation][m_numberOfShells*mshell + nshell] = value;
  //## end Projection::setProjectionElement%3F6F619E00A3.body
}

void Projection::perform (const EnergyPointer& energy, const std::vector<Real>& params, GroupFluxContainer& flux, GroupFluxContainer& fluxError)
{
  //## begin Projection::perform%3F7DE8C80279.body preserve=yes
  
  // each array container in flux, containing one Real Array per spectrum being fitted,
  // has the same number of RealArrays.  The number of spectra in each ArrayContainer
  // is the number of observations. The model proceeds by transforming each observation
  // separately. In general, every array in an observation depends on all the others.
     
  // allocate scratch and initialize. The arrays in the input flux need to be 
  // preserved until the calculation is complete, and then be overwritten
  
  // the error arrays, used rarely, are not filled unless necessary.
  // since this is a marginal path the code is written to avoid pessimizing the 
  // most likely execution path.
  bool isError (!fluxError.empty());
   
  
  doPerform (energy, flux);
  
  if (isError) doPerform (energy,fluxError);
               
             
  //## end Projection::perform%3F7DE8C80279.body
}

void Projection::verifyData () const
{
  //## begin Projection::verifyData%3F8EDADB009A.body preserve=yes
  // ASSUME mix models are only assigned to SOURCE NUMBER 1.
  const size_t SOURCENUM = 1;
  
  if ( datasets->dataArray().size() == 0 )
  {
       throw NoDataPresent("");       
  }
  
  std::map<size_t,std::map<size_t,size_t> >::const_iterator itSourceDgMap = 
                datasets->sourceToDgs().find(SOURCENUM);
  if (itSourceDgMap == datasets->sourceToDgs().end())
  {
     throw YellowAlert("No data sets are assigned to mixing model.\n");
  }
  // If this map exists, it is guaranteed to have at least 1 entry.
  const std::map<size_t,size_t>& dgMap = itSourceDgMap->second;
  
  // Check that an equal # of spectra in each data group are using this
  // model. (This may be overly lenient but we're not requiring that
  // EVERY spectrum in the group has to use this.)
  // Check also that each SpectralData object in the group has identical XFLT
  // values.
  // Ellipsoid is initialized to Ellipsoid::FLAG on construction.
   static Ellipsoid flagValues;
   
   std::map<size_t,size_t> groupCount;
   std::map<size_t,Ellipsoid> ellipseTest;
   std::map<size_t,size_t>::const_iterator itDgMap = dgMap.begin();
   std::map<size_t,size_t>::const_iterator itDgMapEnd = dgMap.end();
   while (itDgMap != itDgMapEnd)
   {
      groupCount[itDgMap->first] = 0;
      ellipseTest[itDgMap->first] = Ellipsoid();
      ++itDgMap;
   }
   size_t count=0; 
   size_t nTotalSpec = datasets->numberOfSpectra();
   for (size_t iSpec=1; iSpec<=nTotalSpec; ++iSpec) 
   {
      const SpectralData* spec = datasets->lookup(iSpec);
      size_t groupNum = spec->parent()->dataGroup();
      if (spec->detector(SOURCENUM-1)) 
      {
         groupCount[groupNum] += 1;
         // get the Ellipsoid definition of the first 
         // spectrum found in this group, and then test subsequent ellipsoids
         // against it.

         // the refactoring static function testEllipsoid can throw an
         // IncompatibleData exception.
         if (ellipseTest[groupNum].a == Ellipsoid::FLAG )
         {
            ellipseTest[groupNum] = testEllipsoid(spec->xflt(), iSpec);
         } 
         else
         {
            Ellipsoid& settingForGroup = ellipseTest[groupNum];
            Ellipsoid currentEllipsoid(testEllipsoid(spec->xflt(), iSpec));
            if ( currentEllipsoid != settingForGroup )
            {
               std::ostringstream msg;
               msg << "\n***  Spectrum: " 
                   << iSpec
                   << "in data group " << groupNum
                           << "\n***  contains ellipsoid definition inconsistent "
                           << "with the group (check data entry order)";
               throw DataOrderingError(msg.str());                        
            }                       
         } 
      }       
   }
   
   std::map<size_t,size_t>::const_iterator itGroupCount = groupCount.begin();
   std::map<size_t,size_t>::const_iterator itGroupCountEnd = groupCount.end();
   count = itGroupCount->second;
   ++itGroupCount;
   while (itGroupCount != itGroupCountEnd)
   {
      if (itGroupCount->second != count) 
      {
         string diag(": all data groups must have the same number of spectra ");
         throw IncompatibleData(diag);
      }
      ++itGroupCount;
   }  
  //## end Projection::verifyData%3F8EDADB009A.body
}

void Projection::doPerform (const EnergyPointer& energy, GroupFluxContainer& fluxes)
{
  //## begin Projection::doPerform%3F9D60580359.body preserve=yes
        
  GroupFluxContainer tmpFlux(fluxes);  
  GroupFluxContainer::iterator t (tmpFlux.begin());
  GroupFluxContainer::iterator tEnd(tmpFlux.end());
  // recall ArrayContainer == std::map<size_t,std::valarray<Real> > so that
  // s->second has a vectorized assignment operator that takes a scalar. 
  while ( t != tEnd )
  {
     ArrayContainer::iterator s (t->second.begin());
     ArrayContainer::iterator sEnd (t->second.end());
     for ( ; s != sEnd; ++s ) s->second = 0;
     ++t;         
  }
  
  
  // the size of each array container is the number of observations 
  // GroupFluxContainer::iterator d (flux.begin());
  // ArrayContainer& primary = d->second;
  // size_t Nobs     (primary.size());
  // this will also be the number of data groups. 
  
               
  size_t Nregions (fluxes.size());  
  
  // roi = region of interest - the region whose observations are currently being
  // computed
  for (size_t roi = 1; roi <= Nregions; ++roi)
  {
     const EnergyPointer::const_iterator en_roi = energy.find(roi);
     const ArrayContainer& energyContainer = *(en_roi->second); 
     ArrayContainer::const_iterator e (energyContainer.begin());
     ArrayContainer& flux_roi = tmpFlux[roi];
     ArrayContainer::iterator tf (flux_roi.begin());
     ArrayContainer::iterator tfEnd (flux_roi.end());
     // counter for the observations, and index for the Ellipsoid objects
     // that define the projection matrix and its indices.
     size_t obs (0);
     while ( tf != tfEnd )
     {
        // this is the flux we are going to modify on this loop iteration,
        // and its corresponding energy.
        const RealArray& en_obs = e->second;
        RealArray& tf_obs = tf->second;
        RealArray tmp(tf_obs.size());
        //     
        // region to be added to the roi flux. Recall that m_numberOfShells can
        // be +1 greater than Nregions if the virtual shell is present. This is
        // used only for volume factor calculations, it can't modify arrays as
        // there are no corresponding arrays.
        for ( size_t region = 0; region < m_numberOfShells; ++region )
        {
           int interiorShellIndex (0);
           Real volumeFactor(0);
           Real majorAxisOfInteriorShell (interiorVolume(obs,region,interiorShellIndex));                
           const Ellipsoid& shell = m_shell[obs][region];
           if (tpout.maxChatter() >= 30 ) tcout << " axis major  " << shell.a << std::endl;
           int r0 (roi-1);
           if ( majorAxisOfInteriorShell != 0 )
           {
              const Ellipsoid& insideShell = m_shell[obs][interiorShellIndex];
              volumeFactor = (projectionElement(obs,region,r0)
                               - projectionElement(obs,interiorShellIndex,r0) ) 
                              /(FOURPIBY3*(shell.a*shell.b*shell.b  
                                - insideShell.a*insideShell.b*insideShell.b));
              if (tpout.maxChatter() >= 30)
              { 
                 tcout << "vol, proj reg, roi, isi, out, in " 
                         << region << " " << r0 << " " 
                         << interiorShellIndex << " "
                         <<  volumeFactor << "  " 
                         << projectionElement(obs,region,r0) 
                         << "  " << projectionElement(obs,interiorShellIndex,r0) 
                         << std::endl;
                 tcout << " inside shell " << insideShell.a  << std::endl;  
              }      
           }
           else
           {
              volumeFactor = projectionElement(obs,region,r0)
                              /(FOURPIBY3*shell.a*shell.b*shell.b);                                  
              if (tpout.maxChatter() >= 30)
              { 
                 tcout << "vol, proj out " << region << " " << r0  << " " 
                         <<  volumeFactor << "  " << projectionElement(obs,region,r0) 
                         << std::endl; 
              }       
           }  
           if ( volumeFactor > 0 && region + 1 <= Nregions )
           {
              size_t r1 (region + 1);
              const EnergyPointer::const_iterator en = energy.find(r1);
              ArrayContainer& fluxr = fluxes[r1];
              ArrayContainer::iterator ir (fluxr.begin());
              const ArrayContainer& en_calc = *(en->second);
              ArrayContainer::const_iterator er (en_calc.begin());
              for (size_t i = 0; i < obs; ++i, ++ir, ++er);
              const RealArray& en_r = er->second;
              RealArray& fluxir = ir->second;
              if ( XSutility::equalVector(en_obs, en_r) )
              {
                 tf_obs  += fluxir * volumeFactor;               
              }
              else
              {
                 using namespace Numerics::Rebin;
                 size_t inputBin(0);
                 size_t outputBin(0);
                 static const Real FUZZY(1.e-06);

                 initializeBins(en_obs, en_r, FUZZY, inputBin, outputBin,
                         m_startBin, m_endBin, m_startWeight, m_endWeight); 
                 rebin(fluxir, m_startBin, m_endBin, m_startWeight, m_endWeight, tmp);
                 tf_obs += volumeFactor*tmp;                                
              }
           }             
        }
        ++obs;
        ++tf;
        ++e;
     }  
  }  
  
  // this will work as a copy assignment, since the dimensions of the arrays under
  // each are identical by definition.
  fluxes = tmpFlux;   
       
  if (tpout.maxChatter() >= 30)
  { 
     t = tmpFlux.begin();
     size_t j(1);
     using namespace std;
     ios_base::fmtflags save (tcout.flags());
     streamsize p(tcout.precision(6));
     GroupFluxContainer::iterator f ( fluxes.begin());
     while ( t != tEnd )
     {
        ArrayContainer::iterator s (t->second.begin());
        ArrayContainer::iterator ff (f->second.begin());
        ArrayContainer::iterator sEnd (t->second.end());
        const EnergyPointer::const_iterator en_j = energy.find(j);
        const ArrayContainer& energyContainer = *(en_j->second);                 
        ArrayContainer::const_iterator e (energyContainer.begin());
        tcout << " DataGroup " << t->first << '\n';
        for ( ; s != sEnd; ++s, ++e ) 
        {
           const RealArray& en = e->second;
           const RealArray& projFlux = s->second;
           const RealArray& unprojFlux = ff->second;
           size_t Nvec = projFlux.size();
           for (size_t k = 0; k < Nvec; ++k)
           {
              tcout << setw(4) << k << "   "  << setw(9)  << en[k+1]
                << "   "  << setw(9) << unprojFlux[k] << "   " 
                << setw(9) << projFlux[k] << endl;            

           } 
        }
        tcout << "\n\n" << flush;
        ++t, ++f, ++j;         
     }

     tcout.flags(save);
     tcout.precision(p);
          
  }
        
  //## end Projection::doPerform%3F9D60580359.body
}

Projection::Ellipsoid Projection::testEllipsoid (const std::map<size_t, Real>& xflt, int spectrumNumber)
{
  //## begin Projection::testEllipsoid%3FA182A50183.body preserve=yes
    if ( xflt.size() >= 3 )
    {
	return Ellipsoid(xflt.find(1)->second, xflt.find(2)->second, xflt.find(3)->second);      
    }
    else
    {
        std::ostringstream diag;
        diag << "\n***  Spectrum number " << spectrumNumber << " has invalid or incomplete" 
	     << " ellipsoid definition\n"
	     << "*** model removed";
        throw IncompatibleData(diag.str());                
    }
  //## end Projection::testEllipsoid%3FA182A50183.body
}

void Projection::initializeForFit (const std::vector<Real>& params, bool paramsAreFrozen)
{
  //## begin Projection::initializeForFit%3FA952FE03D1.body preserve=yes
  initialize(params);
  //## end Projection::initializeForFit%3FA952FE03D1.body
}

void Projection::orderEllipsoids (bool usingCenter)
{
  //## begin Projection::orderEllipsoids%472238780193.body preserve=yes
  // This works on the assumption that all observations contain the
  // same ordering, since verifyData should already have checked that
  // major/minor axes match for all spectra in a group.  Therefore
  // only check the first obs and copy results to the rest.
  std::vector<Ellipsoid>& firstObsShells = m_shell[0];
  // Sets the 0-based shell number of the shell immediately to the
  // inside, and -1 for the innermost.  Shells will often already
  // be loaded in order, but they don't have to be.  
  
  // After a shell is identified as another's inner shell, it is removed
  // from the set.
  std::set<int> remainingShells;
  for (size_t i=0; i<m_numberOfShells; ++i)
     remainingShells.insert(static_cast<int>(i));
  
  for (size_t i=0; i<m_numberOfShells; ++i)
  {
     Real largestInner = .0;
     int idxLargest = -1;
     Ellipsoid& shell_i = firstObsShells[i];
     std::set<int>::iterator itRemaining = remainingShells.begin();
     std::set<int>::iterator itEnd = remainingShells.end();
     while (itRemaining != itEnd)
     {
        int testIdx = *itRemaining;
        if (shell_i.a > firstObsShells[testIdx].a)
        {
           if (firstObsShells[testIdx].a > largestInner)
           {
              largestInner = firstObsShells[testIdx].a;
              idxLargest = testIdx;
           }
        }
        ++itRemaining;
     }
     shell_i.innerShellNum = idxLargest;
     if (idxLargest >= 0) 
        remainingShells.erase(idxLargest);
  }
  
  // Enforce the rule that if a center hole is specified, its major
  // axis doesn't extend beyond any of the shells.  ie. it must
  // truly be innermost.
  if (usingCenter)
  {
     if (firstObsShells[m_numberOfShells-1].innerShellNum != -1)
     {
        string errMsg("The 3 fixed parameters of the projct component must specify the inner-most boundary.");
        errMsg += "\n  Their axes must not extend beyond any of those given by the XFLT keywords";
        errMsg += "\n  in the data sets.\n";
        throw YellowAlert(errMsg); 
     }
  }
  
  for (size_t iObs=1; iObs < m_observations; ++iObs)
  {
     std::vector<Ellipsoid>& obsShells = m_shell[iObs];
     for (size_t iShell=0; iShell<m_numberOfShells; ++iShell)
        obsShells[iShell].innerShellNum = firstObsShells[iShell].innerShellNum;  
  }
  //## end Projection::orderEllipsoids%472238780193.body
}

// Additional Declarations
  //## begin Projection%3F6F1D3C000C.declarations preserve=yes
  //## end Projection%3F6F1D3C000C.declarations

//## begin module%3F6F20500053.epilog preserve=yes
//## end module%3F6F20500053.epilog
